#!/usr/bin/perl
#Make sure the above line is the path
#to perl on your server.
#################################################################

require 'config.dat';                              #Require the config file
$vnum = "3.0";                                     #Version Number

read(STDIN, $input, $ENV{'CONTENT_LENGTH'});       #Parse HTML forms

	# split the input
	@pairs = split(/&/, $input);

	# split the name/value pairs
	foreach $pair (@pairs) {

	($name, $value) = split(/=/, $pair);

	$name =~ tr/+/ /;
	$name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$value =~ s/<([^>]|\n)*>//g;

  $FORM{$name} = $value;
    }
#######################################################################
##########Translate the data from the HTML form into scalar variables##
#######################################################################
$replace = "_____";                                                 # Value for profanit filter
$zach = $FORM{'zach'};                                              #used in unless statement below
$addthis2story = $FORM{'addthis2story'};                            #Initalizes for value for chapter
$usrname = $FORM{'usrname'};                                        #Initalizes for value for users name
$usrmail = $FORM{'usrmail'};                                        #Initalizes for value for user email
$addr = $ENV{'REMOTE_ADDR'};                                        #Users IP address
$usragent = $ENV{'HTTP_USER_AGENT'};                                #User Agent
$usrmailname = "\<A HREF\=\"mailto\:$usrmail\"\>$usrname\<\/A\>";   #autolink email thing                                
&get_date;                                                          #Get the date and time
$back = $ENV{'HTTP_REFERER'};                                       #Back button data

#######################################################################
####Generate the configuration form page###############################
#######################################################################


unless ($zach eq "addchapter") {               #Main input page

print <<"(END ERROR HTML)";
Content-type: text/html\n
<HTML>

<HEAD>
	<META HTTP-EQUIV="Content-Type" CONTENT="text/html;CHARSET=iso-8859-1">
	<META NAME="GENERATOR" Content="Add2Story Pro by Zachary Jorgensen 1999">
	<TITLE>$title</TITLE>
</HEAD>

$pgformat

<FORM ACTION="$scriptlocation" METHOD="POST" ENCTYPE="application/x-www-form-urlencoded">
<P>
<TABLE BORDER="0" WIDTH="100%" HEIGHT="386">
	<TR>
		<TD WIDTH="100%" VALIGN="TOP">


			<BLOCKQUOTE>
			<P ALIGN="CENTER"><font face="Verdana, Arial" size="5">$title</font></P>
			<P>
                  $header
                  <p>
                 <font face="Verdana, Arial" size="2"> Klicke <A HREF="$scriptURL">hier</A> zum lesen der Geschichte, oder benutze das Formular um Dein Kapitel zur Geschichte beizutragen.</font>  </P>

			<P><font face="Verdana, Arial" size="2">Name:</font><INPUT TYPE="TEXT" NAME="usrname" SIZE="25"></P>

			<P><font face="Verdana, Arial" size="2">E-Mail:</font><INPUT TYPE="TEXT" NAME="usrmail" SIZE="25"></P>

			<P><font face="Verdana, Arial" size="2">Kapitel:</font> <BR>
			<font face="Verdana, Arial" size="1">Auto Zeilenumbruch ist an.</font>
			 <BR>
			</FONT><TEXTAREA WRAP=VIRTUAL NAME="addthis2story" ROWS="12" COLS="51"></TEXTAREA></P>

			<P><INPUT TYPE="HIDDEN" NAME="zach" SIZE="-1" VALUE="addchapter"></P>

			<P><INPUT TYPE="SUBMIT" VALUE="Dein Kapitel eintragen"> <INPUT TYPE="RESET" NAME="Reset" VALUE="Abbrechen"></P>

			</BLOCKQUOTE>

			<DIV ALIGN="RIGHT">
			<P>
			<TABLE BORDER="0" WIDTH="24%">
				<TR>
					<TD WIDTH="100%" VALIGN="TOP">   <font face="Verdana, Arial" size="1">Die unendliche Geschichte stammt von<br> <A HREF="http://www.zachsarchive.cjb.net">Zach's
						Archive</A><br> und wurde bersetzt von<br> <A HREF="http://www.inspire-net.de">Inspire-net</a></font></TD>
				</TR>
			</TABLE>

</DIV>
		</TD>
	</TR>
</TABLE>

</FORM>

</BODY>

</HTML>
(END ERROR HTML)
exit; 
}
if ($usrname eq ""){         #If the user does not enter a name, call them Anonamyous
$usrname = "Anonymous";
}
############NO CHAPTER ERROR#############
if ($addthis2story eq ""){                   #If no chapter is entered, print error
print <<"(END ERROR HTML)";
Content-type: text/html\n
<HTML>

<HEAD>
	<META HTTP-EQUIV="Content-Type" CONTENT="text/html;CHARSET=iso-8859-1">
	<META NAME="GENERATOR" Content="Visual Page 1.1a for Windows">
	<TITLE>Error:  Kein Text zur Geschichte notiert</TITLE>
</HEAD>

$pgformat
<CENTER>
<P>
<TABLE BORDER="0" WIDTH="54%" HEIGHT="200">
	<TR>
		<TD WIDTH="100%" HEIGHT="20" VALIGN="TOP" BGCOLOR="$tblheadbg">
			<P ALIGN="CENTER"><FONT SIZE="4" COLOR="$tblheadtxt"><B>$title</B></FONT>
		</TD>
	</TR>
	<TR>
		<TD WIDTH="100%" HEIGHT="166" VALIGN="TOP" BGCOLOR="$tblbg">
			<P><FONT COLOR="$tbltxt"><B>Error: Kein Eintrag</B>


			<BLOCKQUOTE>
			<P><B><BR>
			Sorry $usrname, es wurde kein Text zu $title geschrieben, so kann aber die Geschichte nicht fortgesetzt werden.
			Bitte berichtige das.</FONT></B><br>
			<br><a href="$back">Zurck</a>
</BLOCKQUOTE>
		</TD>
	</TR>
</TABLE>

</CENTER>

</BODY>

</HTML>
(END ERROR HTML)
exit;
}
##########Some Junk###############
#Misc options
if ($usrname eq "termsofuse"){                                       #View terms of use
print "Location: http://zachsarchive.cjb.net/tou.html\n\n";
exit;
}

if ($usrname eq "upgrade"){                                          #Upgrade Option
print "Location: http://zachsarchive.cjb.net/add2story.html\n\n";
exit;
}

if ($usrname eq "about:add2story"){                                  #About the script
print "Location: http://zachsarchive.cjb.net/add2story.html\n\n";
exit;
}


########################### The Profanity censor  IMPROVED 04/22/00
if ($censor eq "on"){
#This line here checks for profanity and replaces it with $replace   =DRASTICALLY IMPROVED=
$addthis2story =~ s/\bFuck\b|\bFucking\b|\bFuckin'\b|\bBitch\b|\bAss\b|\bShit\b|\bpussy\b|\bTit\b|\bCunt\b|\bClit\b|\bCock\b|\bhor\b|\bboob\b|\b\@\$\$\b/$replace/gi;
#Did your mommy teach not to say these words?

}

#security IMPROVED 04/22/00
$addthis2story =~ s/< *((SCRIPT)|(APPLET)|(EMBED))[^>]+>//ig;  #Don't let users inbed jave
$addthis2story =~ s/<!--#[^>]+>//ig;                           #don't let users imbed SSI Tags
$addthis2story =~ s/< *IMG[^>]+>//ig;                          #Dont let users post image files
$addthis2story =~ s/< *a href="+">//ig;                        #Dont let users post links


##########################################################################
#### Write chapter to file, do the logging and mail ######################
##########################################################################

#DUPLICATE CHAPTER CHECKING                 #Check to see if this chapter already exists
if ($dupecheck eq "on"){
open(FILE,"$storyfile") || die $!;
    @chapters = <FILE>;
    foreach $line (@chapters) {
        if ($line =~ /$addthis2story/i) {
            &dupentry;
            exit;
        }
    }
    close(FILE);
}

#######Added 04/22/00 - Update to auto-link email thingi############
if ($usrmail eq ""){
$usrmailname = "$usrname";
}
#############################################################################
#############WRITE THE CHAPTER TO THE STORY##################################
#############################################################################
###I wouldn't edit any of this if I were you because it's really jumbled and#
###kind of confuseing and if you screw something up you're gonna have a time# 
###fixin' it!                                                               #
#############################################################################
#New chapter tag
$instance = "<!-- Next Chapter -->";
$replace = "

<P>
<TABLE BORDER=\"0\" WIDTH=\"100\%\" HEIGHT=\"28\">
<TR>
		<TD WIDTH=\"18\%\" VALIGN=\"TOP\"><font face=\"Verdana, Arial\" size=2>Kapitel von $usrmailname <br>$date</font>		</TD>
		<TD WIDTH=\"82\%\" VALIGN=\"TOP\">

			<BLOCKQUOTE>
<font face=\"Verdana, Arial\" size=\"2\">$addthis2story</font>			</BLOCKQUOTE>
		</TD>
	</TR>
</TABLE>
<!-- Next Chapter -->
	";  #<-- Don't Remove these!

#open your file for writing, write to it then close file
open(STORY, "$storyfile") or die('could not open $storyfile for reading, stopped ');
 
@story= <STORY>;

close(STORY);

open(STORY, ">$storyfile") or die('could not open $storyfile for writing, stopped ');

foreach $line(@story)
	{	
chomp($line);
$line =~ s/$instance/$replace/gi; 


   print STORY "$line\n";

}

close (STORY);

##############################################


#If logging is on, log users name and IP, date, and time to log file
if ($logging eq "on"){
open (LOG, ">>$logfile") || die "Can't open FILE: $logfile\n";
print LOG "Ein Kapitel, gepostet von $usrname  \[$addr\]  $date \) \n";
close(LOG);
 }

#If mail option is on, then send mail to tell owner that a chapter was added
if ($mail eq "on") {
   open (MAIL,"|$mailprog -t");
        print MAIL "To: $recipient\n";
        print MAIL "From: $usrname <$usrmail> \n";
        print MAIL "Subject: Kapitel geschrieben: $title\n\n";
        print MAIL "$date\n\n";
        print MAIL "$usrname hat ein Kapitel zu Geschichte geschrieben\n $scriptURL\n\n";
        print MAIL "Below is the chapter $usrname added to $title:\n\n$addthis2story\n";
print MAIL "\nZusaetzliche Infos zum User $usrname:\n IP: $addr\n User Agent: $usragent\n";
   close (MAIL);
 }

#######################################################################
#### Print Finish message #############################################
#######################################################################

print <<"(END ERROR HTML)";
Content-type: text/html\n

<HTML>

<HEAD>
	<META NAME="GENERATOR" Content="Add2Story Pro by Zachary Jorgensen 1999">
	<TITLE>$title: Kapitel geschrieben</TITLE>
</HEAD>

$pgformat

<CENTER>
<P>
<TABLE BORDER="0" WIDTH="57%" HEIGHT="233">
	<TR>
		<TD WIDTH="100%" HEIGHT="20" VALIGN="TOP" BGCOLOR="$tblheadbg">
			<P ALIGN="CENTER"><FONT SIZE="4" COLOR="$tblheadtxt"><B>$title</B></FONT>
		</TD>
	</TR>
	<TR>
		<TD WIDTH="100%" HEIGHT="196" VALIGN="TOP" BGCOLOR="$tblbg">
			<P><FONT COLOR="$tbltxt"><B>Aktion erfolgreich: Kapitel eingetragen!<BR>
			Danke fr Deinen Beitrag $usrname.   Unterhalb ist eine Kopie Deines Kapitels zu $title:</B></P>


			<BLOCKQUOTE>
			<P><B>$addthis2story<B></P>

			</BLOCKQUOTE>

			<P><B></B></P>

			<P><B>Klicke </B><A HREF="$scriptURL"><B>hier</B></A><B> zur Anzeige des $title.</FONT></B>
		</TD>
	</TR>
</TABLE>

</CENTER>

</BODY>

</HTML>
(END ERROR HTML)
exit;

# a sub to get the date
sub get_date {

    # Define arrays for the day of the week and month of the year.           #
    @days   = ('Sonntag','Montag','Dienstag','Mittwoch',
               'Donnerstag','Freitag','Samstag');
    @months = ('Januar','Februar','Mrz','April','Mai','Juni','Juli',
                 'August','September','Oktober','November','Dezember');

    # Get the current time and format the hour, minutes and seconds.  Add    #
    # 1900 to the year to get the full 4 digit year.                         #
    ($sec,$min,$hour,$mday,$mon,$year,$wday) = (localtime(time))[0,1,2,3,4,5,6];
    $time = sprintf("%02d:%02d:%02d",$hour,$min,$sec);
    $year += 1900;

    # Format the date.                                                       #
    $date = "$days[$wday], $months[$mon] $mday, $year um $time";

}

#A sub that detects duplicate entries
sub dupentry
{
print <<"(END ERROR HTML)";
Content-type: text/html\n
<HTML>

<HEAD>
	
	<TITLE>Error: Doppelter Eintrag</TITLE>
</HEAD>

$pgformat

<CENTER>
<P>
<TABLE BORDER="0" WIDTH="54%" HEIGHT="200">
	<TR>
		<TD WIDTH="100%" HEIGHT="20" VALIGN="TOP" BGCOLOR="$tblheadbg">
			<P ALIGN="CENTER"><FONT SIZE="4" COLOR="$tblheadtxt"><B>$title</B></FONT>
		</TD>
	</TR>
	<TR>
		<TD WIDTH="100%" HEIGHT="166" VALIGN="TOP" BGCOLOR="$tblbg">
			<P><FONT COLOR="$tbltxt"><B>Error: Doppelter Eintrag</B>


			<BLOCKQUOTE>
			<P><B><BR>
			Dieses Kapitel wurde schon eingetragen.  Doppelte Eintrge sind nicht erlaubt,
			bitte berichtige das.</FONT></B><br>
			<br><a href="$back">Zurck</a>

			</BLOCKQUOTE>
		</TD>
	</TR>
</TABLE>

</CENTER>

</BODY>

</HTML>
(END ERROR HTML)
exit;
}


